<?php

define("EENOSLOG", true);

function debug_log($data){    
        $logfile=dirname(__FILE__).'/debug.log';
        if(is_array($data)) {
            file_put_contents($logfile,  print_r($data, true), FILE_APPEND);
        
        } else {
            file_put_contents($logfile, $data . "\n", FILE_APPEND);
        }
}
// Integrate into  Eenos BFD service 
function bfd_add($user){
    $ip=get_my_ip();    
    $data=array(
        'ip' => $ip,
        'date' => date('d/m/Y H:i:s'),
        'service' => "filemanger",
        'info' => "Login failure on file manager service",
        'user' => $user
    );
    $bdata=json_encode($data);
    if (file_exists("/run/eenosbfd.socket")){
        $sock = stream_socket_client('unix:///run/eenosbfd.socket', $errno, $errstr);
        fwrite($sock, $bdata);        
        fclose($sock);
                
    }
}

function get_blacklist(){
    $dbfile='/var/lib/eenos/bfd.db';
    $bs=array();
    if( file_exists($dbfile)){        
        $db = new SQLite3($dbfile,SQLITE3_OPEN_READONLY);
        if($db){            
            $result=$db->query('SELECT ip FROM blacklist'); 
            if($result){ 
                while ($row = $result->fetchArray()) 
                    {
                        array_push($bs,$row[0]);                    
                    }
            }
            $db->close();
        }
    }
    array_push($bs,"0.0.0.0");
    array_push($bs,"::");
    // debug_log($bs);
    return $bs;
}

function get_whitelist(){
    $dbfile='/var/lib/eenos/bfd.db';
    $bs=array();
    if( file_exists($dbfile)){        
        $db = new SQLite3($dbfile,SQLITE3_OPEN_READONLY);
        if($db){            
            $result=$db->query('SELECT ip FROM whitelist');    
            if($result){        
            while ($row = $result->fetchArray()) 
                {                    
                    array_push($bs,$row[0]);                    
                }
            }
            $db->close();
        }
    }
    array_push($bs,"127.0.0.1");
    array_push($bs,"::1");
    // debug_log($bs);
    return $bs;
}

function isUserID($username){ return (bool)preg_match('/^[\w]{2,20}$/i', $username);}
function iseenosuer($username){
    if (file_exists("/var/eenos/users/$username")){        
        return true;
    }else{        
        return false;
    }
}
function is_notsuspended($username){
    if (file_exists("/var/eenos/suspended/$username")){        
        return false;
    }else{        
        return true;
       
    }
}
function sauthenticate($user, $pass){
    if (isUserID($user) && iseenosuer(($user))){
        if (is_notsuspended($user)){
        $shad =  preg_split("/[$:]/",`cat /etc/shadow | grep "^$user\:"`);
        if (!isset($shad[2]) || !isset($shad[3])) return false;
        $mkps = preg_split("/[$:]/",crypt($pass, '$'.$shad[2].'$'.$shad[3].'$'));         
        return ($shad[4] == $mkps[3]);
        }else{
            return false;
        }
    }
    else{
        return false;
    }
    
  }

 function auth_pam($user,$password){    
    if (pam_auth($user,$password)){
        return true;
    }else{
        bfd_add($user);
        return false;
    }
 } 
function password_verify_eenos($uname,$lpass){       
    if(function_exists('pam_auth')){
        $result=auth_pam($uname,$lpass);
        return $result;
    }else{
        if ( sauthenticate( $uname, $lpass) ) {
            return true;
        }else{
            bfd_add($uname);
            return false;

        }
    }
}

function get_user_home($user){
    $ufile="/var/eenos/users/".$user;
    $hm="data/";
    foreach(file($ufile) as $line) {
        if (str_starts_with($line,'homedir:')){
            $hm=trim(explode(":",trim($line))[1]);
            return $hm;            
        }          
    }

}

function fm_rchown($path, $user)
{
    if (is_dir($path)) {
        chown($path,$user);
        chgrp($path,$user);        
        $objects = scandir($path);
        $ok = true;
        if (is_array($objects)) {
            foreach ($objects as $file) {
                if ($file != '.' && $file != '..') {
                    if (!fm_rchown($path . '/' . $file,$user)) {
                        $ok = false;
                    }
                }
            }
        }
        return $ok;
    } elseif (is_file($path)) {
        chown($path,$user);
        chgrp($path,$user);         
    }
    return false;
}

function get_my_ip() {
    $ipaddress = '';
    if (isset($_SERVER['HTTP_CLIENT_IP']))
        $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
    else if(isset($_SERVER['HTTP_X_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_X_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
    else if(isset($_SERVER['HTTP_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_FORWARDED'];
    else if(isset($_SERVER['REMOTE_ADDR']))
        $ipaddress = $_SERVER['REMOTE_ADDR'];
    else
        $ipaddress = 'UNKNOWN';
    return $ipaddress;
}



// Possible rules are 'OFF', 'AND' or 'OR'
// OFF => Don't check connection IP, defaults to OFF
// AND => Connection must be on the whitelist, and not on the blacklist
// OR => Connection must be on the whitelist, or not on the blacklist
$ip_ruleset = 'OR';

// Should users be notified of their block?
$ip_silent = false;

// IP-addresses, both ipv4 and ipv6
// $ip_whitelist = array(
//     '127.0.0.1',    // local ipv4
//     '::1'           // local ipv6
// );
$ip_whitelist=get_whitelist();
// IP-addresses, both ipv4 and ipv6
// $ip_blacklist = array(
//     // '122.252.225.47',
//     '0.0.0.0',      // non-routable meta ipv4
//     '::'            // non-routable meta ipv6
// );

$ip_blacklist=get_blacklist();
// debug_log($ip_whitelist);